#!/usr/bin/perl

if (($#ARGV < 3) || ($#ARGV > 4))
{
  die "ERROR on parameters\n  General usage: \n\$>mkThumbnails.pl /path/of/directory/source extensionIN sizeOptions /path/of/directory/destination [extensionOUT]\n\n  Sample usage: \n\$>mkThumbnails.pl ./ png 30% _thumlbnails gif\n\n";
}

if ($#ARGV == 3)
{ $extensionIn = $ARGV[1];
  $extensionOut = $extensionIn;  
}

if ($#ARGV == 4)
{ $extensionIn = $ARGV[1];
  $extensionOut = $ARGV[4];
}

$sizeOptions = $ARGV[2];

## --------------------------------------------------
## Extract path and file name
$baseDirectory = $ARGV[0];
$thumbnailsDirectory = $ARGV[3];


## --------------------------------------------------
## convert pics into new thumbnails directory
chdir "$baseDirectory";

@images = map {glob} ("*.$extensionIn");

if ($#images == -1)
{ die "Nothing to do: no images $baseDirectory/*.$extensionIn\n";
}

## --------------------------------------------------
## create the directory for output
if (!(-d "$thumbnailsDirectory"))
{ if (!(mkdir "$thumbnailsDirectory"))
  { die "Unable to create directory $thumbnailsDirectory\n Aborting...\n";
  }
}

## --------------------------------------------------
## Processing
print "Creating ";
print ($#images +1);
print " thumbnails, into ";
print ($thumbnailsDirectory);
print "...\n";
foreach $i (0 .. $#images) 
{
  print ($i+1);
  print " ";
  @nameOfImageArray = split /\./ , $images[$i];
  $nameOfImage = $nameOfImageArray[0];
  @commandLineArray = ("convert" , "-sample" , $sizeOptions, "$nameOfImage.$extensionIn" , "$thumbnailsDirectory/$nameOfImage.$extensionOut");
  system @commandLineArray;
## debug
#  print (join(' ', @commandLineArray));
#  print "\n";
}
print "...Done!\n";

exit 0;
